<?
/*
###############################
#
# Advertising Page Manager plugin script for CC
# verified with CC versions 1.9x
# http://www.jkirkpatrick.org/
#
###############################
#
# Date: Jan 18, 2004
# Web: http://www.jkirkpatrick.org/
# Mail: plugins@jkirkpatrick.org
#
###############################
#
#Copyright 2004 Jeremiah Kirkpatrick, All rights Reserved
#Use of this plugin acknowleges acceptance of the license agreement.
#
###############################
*/
setlocale(LC_MONETARY, 'en_US');
$plugins[]=array("name"=>"Advertising Page Manager", "classname"=>"advert_page");
class advert_page extends plugin_base
{
	var $class_name = "advert_page";
	var $path = 'advpage/';
	var $author = "Jeremiah K.";
	var $web = "http://www.jkirkpatrick.org/";
	var $name = "Advertising Page Manager (Freeware)";
	var $date = "12-08-05";
	var $table_config ="advert_config";
	var $table_items = "advert_items";
	var $table_groups ="advert_groups";
	var $version = "2.05";
	var $validate;
	var $postname;
	var $referal;
	var $menu;
	var $license;
	var $all;
	var $file_name;
	var $status;
  var $p_owner;
	var $ph=FALSE;
	var $pay_modules;
	var $pay_modules_info;
	var $db_version=4;
	function advert_page()
	{
		global $mysql_database, $HTTP_SESSION_VARS, $userinfo;
		$this->table_config = mysql_prefix."advert_config";
		$this->table_items = mysql_prefix."advert_items";
		$this->table_groups = mysql_prefix."advert_groups";
		$this->file_name = strtok($this->path, '/');
		$this->path=dirname(__FILE__).'/';
		if($HTTP_SESSION_VARS['username'])
			{$this->postname=&$HTTP_SESSION_VARS['username'];}
		else
			{$this->postname= "a Guest";}
		if($HTTP_SESSION_VARS['sessionref'])
			{$this->referal=$HTTP_SESSION_VARS['sessionref'];}
		else
			{$this->referal= "N/A";}
		if(!$this->load_modules_pay())
			echo "Error loading Pay Modules!";
	}
	function admin_page()
	{
		global $HTTP_SESSION_VARS, $mysql_database;
		if($_GET['page']) $load=&$_GET['page'];
		if($_POST['page']) $load=&$_POST['page'];
		$db_stat=$this->check_db_version();
		if($_GET['page']!='ininstall' &&  $_GET['page']!='install')
		{
			if(!$db_stat)
				$status="<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=install\"><font color=#FF0000>Not installed, click to Install</font></a>";
			else if ($db_stat===TRUE)
				$status="<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=uninstall\"><font color=#00FF00>Installed, click to Uninstall</font></a>";
			else
				$status="<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=$_GET[page]&upgrade_db=1\"><font color=#FF0000>Upgrade Database</font></a>";
		}else{
			if($_GET['page']!='ininstall')
				$status="<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=install\"><font color=#FF0000>Not installed, click to Install</font></a>";
			else
				$status="<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=uninstall\"><font color=#00FF00>Installed, click to Uninstall</font></a>";
		}
		$this->menu = "<p align=\"right\"><b>STATUS:</b> $status</p>
		<p align=\"center\">
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name\">Main</a>&nbsp;|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=items_conf\">Items</a>&nbsp;|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=groups_conf\">Item Groups</a>&nbsp;|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=about\">About</a>&nbsp;|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=readme\">Read Me</a><br>
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=psmgt\">Payment System Management</a><br>
		</p>\n";
		$this->p_owner=system_value('tcp_owner');
		echo $this->menu.$this->status;
		if(method_exists($this, $load))
		{call_user_func(array($this, $load));$this->page_footer();return;}
		$this->load_page($this->path.'admin.admin.php', 0);
		$this->page_footer();
	}
	function check_db_version()
	{
		global $mysql_database, $HTTP_SESSION_VARS;
		$fields=@mysql_list_fields($mysql_database, $this->table_config);
		if(!$fields)
			return FALSE;
		$current_ver=system_value('advpagedbver');
		if(intval($current_ver)==intval($this->db_version))
			return TRUE;
		if(!$_GET['upgrade_db'])
			return 'upgrade';
		include($this->path.'upgrade.db.php');
		return TRUE;
	}
	function category_list($type=0)
	{
		global $ADVERT_EXCLUDES, $bgcolor1, $bgcolor2, $tdclass1, $tdclass2;
		$excludes=explode(';', $ADVERT_EXCLUDES);
		$results=@mysql_query("SELECT * FROM ".mysql_prefix.$this->table_groups." ORDER BY `name`");
		switch($type)
		{
			default:
			case 0:
				include($this->path.'cats.style0.php');
				break;
			case 1:
				include($this->path.'cats.style1.php');
				break;
			case 2:
				include($this->path.'cats.style2.php');
				break;
		}
	}
	function load_modules_pay()
	{
		if(isset($this->pay_modules))
			return TRUE;
		$modpath=$this->path.'mod_psmgt/';
		if(!@file_exists($modpath.'/base.class.php'))
			return FALSE;
		include_once($modpath.'/base.class.php');
		$hDir=dir($modpath);
		while(($entry = $hDir->read())!==FALSE)
		{
			if($entry=='.' || $entry=='..' || $entry=='base.class.php')
			   continue;
			$filename=$modpath.$entry;
			if(is_dir($filename))
				continue;
			if(!@file_exists($filename))
			   continue;
			include_once($filename);
		}
		foreach($this->pay_modules_info as $value)
		{
			$this->pay_modules[$value['classname']] = new $value['classname'] ($modpath, $this->table_config, $this->table_items, $this->table_groups);
		}
		return TRUE;
	}
	function load_page($page, $style=0)
	{
		switch(intval($style))
		{
			case '0':
			if(file_exists($page))
				include($page);
			else
				echo "<font color=#FF0000>Missing or renamed required configuration file!($page)</font>\n";
			break;
			case '1':
			if(file_exists($page))
			{
				echo "<textarea cols=90 rows=40>\n";
				$fp=fopen($page, 'r');
				while(!feof($fp))
					echo fgets ($fp, 1024);
				fclose($fp);
				echo "</textarea>\n";
			}
			else
				echo "<font color=#FF0000>Missing or renamed required configuration file!($page)</font>\n";
			break;
			default:
				echo "<font color=#FF0000>Load Page Error: Invalid load style... death...</font>\n";
				exit(1);
			break;
		}
	}
	function psmgt()
	{
		$this->load_page($this->path.'psmgt.admin.php', 0);
	}
	function items_conf()
	{
		$this->load_page($this->path.'items.admin.php', 0);
	}
	function groups_conf()
	{
		$this->load_page($this->path.'groups.admin.php', 0);
	}
	function ad_menu()
	{
		global $adv_style;
		$this->category_list($adv_style);
		$this->load_group($_GET['group'], $adv_style);
	}
	function public_page()
	{
		global $HTTP_SESSION_VARS;
		if($HTTP_SESSION_VARS['username'])
			$this->qt_refresh();
		$this->automation_check();
		$this->ad_menu();
	}
	function qt_refresh()
	{
		global $HTTP_SESSION_VARS;
		$result = @mysql_query("SELECT SUM(amount)/10000000 AS 'total' FROM `accounting` WHERE `type` = 'cash' AND `username`='".$HTTP_SESSION_VARS['username']."'");
		list($HTTP_SESSION_VARS['quick_cash_total'])=@mysql_fetch_array($result);
		$HTTP_SESSION_VARS['quick_cash_total']=round($HTTP_SESSION_VARS['quick_cash_total'], 6);
		$result = @mysql_query("SELECT SUM(amount)/100000 AS 'total' FROM `accounting` WHERE `type` = 'points' AND `username`='".$HTTP_SESSION_VARS['username']."'");
		list($HTTP_SESSION_VARS['quick_points_total'])=@mysql_fetch_array($result);
		$HTTP_SESSION_VARS['quick_points_total']=round($HTTP_SESSION_VARS['quick_points_total'], 6);
	}
	function load_group($load_group, $style=0)
	{
		global $HTTP_SESSION_VARS, $ADVERT_EXCLUDES, $bgcolor_1, $bgcolor_2, $tdclass_1, $tdclass_2, $adv_style;
		if(isset($adv_style) || !$style)
			$style=$adv_style;
		if($HTTP_SESSION_VARS['username'])
			$this->qt_refresh();
		if($this->automation_check())
			return;
		if($load_group)
		{
			$points=@mysql_fetch_array(@mysql_query("SELECT * FROM `".$this->table_config."` WHERE `name`='predeem'"));
			$group=@mysql_fetch_array(@mysql_query("SELECT * FROM ".$this->table_groups." WHERE `id`='$load_group'"));
			switch($style)
			{
				default:
				case 0:
					include($this->path.'body.style0.php');
					break;
				case 1:
					include($this->path.'body.style1.php');
					break;
				case 2:
					include($this->path.'body.style2.php');
					break;
			}
		}
	}
	function automation_check()
	{
		global $HTTP_SESSION_VARS;
		$this->load_modules_pay();
		foreach($this->pay_modules_info as $value)
		{
			$this->pay_modules[$value['classname']]->load_settings();
			if($this->pay_modules[$value['classname']]->work_check())
				if($this->pay_modules[$value['classname']]->automate)
					$this->pay_modules[$value['classname']]->auto_check();
		}
	}
	function fetch_forms($name, $total, $item_num=0, $no_option)
	{
		global $HTTP_SESSION_VARS;
		$this->load_modules_pay();
		if($HTTP_SESSION_VARS['sessionref'])
			$ref="$HTTP_SESSION_VARS[sessionref]";
		else
			$ref="$_GET[refid]";
		$payment_forms="<table border=0 width=100% align=center>
<tr>\n";
		$idx=0;
		foreach($this->pay_modules_info as $value)
		{
			$this->pay_modules[$value['classname']]->load_settings();
			if($this->pay_modules[$value['classname']]->is_allowed($no_option))
			{
				if($this->pay_modules[$value['classname']]->active)
				{
					$payment_forms.="<td align=center valign=top>\n";
					if(!$xval=$this->pay_modules[$value['classname']]->extra_value($total))
					{
						$form_data=$this->pay_modules[$value['classname']]->form($name, $item_num, $total, $ref);
						unset($xval);
					}
					else
						$form_data=$this->pay_modules[$value['classname']]->form($name, $item_num, $xval['value'], $ref);
					$payment_forms.=$form_data['form'].$form_data['markup'];
					$payment_forms.="</td>\n";
					$idx++;
					if($idx>4)
					{
						$payment_forms.="</tr>\n<tr>\n";
						$idx=0;
					}
				}
			}
		}
		echo $payment_forms.'</tr></table>';
	}
	function about()
	{
		$this->load_page($this->path.'about.admin.php', 0);
	}
	function readme()
	{
		$this->load_page($this->path.'README', 1);
	}
	function float2curency($value)
	{
		return '$'.number_format($value,2);
	}
	function phone_home()
	{
		$this->load_page($this->path.'phone_home.php', 0);
	}
	function install()
	{
		$this->load_page($this->path.'install.admin.php', 0);
	}
	function uninstall()
	{
		$this->load_page($this->path.'uninstall.admin.php', 0);
	}
	function page_footer()
	{
		echo '<hr width=80%><table border="0" width="100%" align="center">
<tr bgcolor="#DDDDDD">
<td align="left" colspan="2"><p>These plugins are now offered as freeware to anybody who wishes to use them.
</td>
</tr>';
	/*BEGIN COPYRIGHT NOTICE*/
	/*WARNING: TAMPERING WITH THIS SECTION OF CODE OR OTHERWISE CIRCUMVENTING IT'S EXECUTION BY BLOCKING OR REMOVING THE FUNCTION CALLS IS A VIOLATION IN THE FREEWARE LICENSE AGREEMENT WHICH GOVERNS YOUR USE OF THIS SCRIPT.*/
echo '<tr>
<td colspan="2" align="center">
'.$this->name.'<br>
&copy;2006 JKirkpatrick, All Rights Reserved<br>
</td>
</tr>';
	/*END COPYRIGHT NOTICE*/
echo '</table>';
	}
}
